typedef enum { S1, S2, S3, S4, S5, S6, S7, S8,
                S9, S10, S11, S12, S13, S14, S15} whole_state;

module environment ( clock );

input clock;
output[7:0]     ip_mem_data;
output[7:0]     ip_fab_data;
output[8:0]     ip_mem_addr_r;
output[8:0]     ip_mem_addr_c;
output          ip_mem_rd_req;
output          ip_mem_wr_en;
output[7:0]     op_fifo_data;
output          op_fifo_wr_en;
output          op_fab_ack;
output          op_fifo_soc;
wire            framestart;
wire            npc_rst_n;
wire            ip_empty;
wire            rx_rd_req;
wire            rx_ip_soc;
wire [7:0]      rx_ip_data;
wire            ctr_sz;
wire            ctr_ip;
wire            fab_ip_ack;
wire            fab_op_data;

whole_state wire state;
npc  npc0(framestart, 
                clock,
                npc_rst_n,
                ip_empty,
                rx_rd_req,                              
                rx_ip_soc,
                rx_ip_data,
                ctr_sz,
                ctr_id,
                ip_mem_data,
                mem_ip_data,
                ip_fab_data,
                fab_ip_ack,
                ip_mem_addr_r,
                ip_mem_addr_c,
                ip_mem_rd_req,
                ip_mem_wr_en,
                fab_op_data,
                op_fifo_data,
                op_fifo_wr_en,
                op_fab_ack,
                op_fifo_soc
                );
input_data input_data0(
                state, 
                framestart, 
                clock,
                npc_rst_n,
                ip_empty,
                rx_rd_req,                              
                rx_ip_soc,
                rx_ip_data,
                ctr_sz,
                ctr_id,
                mem_ip_data,
                fab_ip_ack,
                fab_op_data
                );

endmodule

module input_data(
                state,
                framestart, 
                clock,
                npc_rst_n,
                ip_empty, 
                rx_rd_req,
                rx_ip_soc,
                rx_ip_data,
                ctr_sz,
                ctr_id,
                mem_ip_data,
                fab_ip_ack,
                fab_op_data
                );
input           clock;
output          framestart;
output          npc_rst_n;
output          rx_rd_req;
output          rx_ip_soc;
output [7 : 0]  rx_ip_data;
output          ctr_sz;
output          ctr_id;
output [7 : 0]  mem_ip_data;
output          fab_ip_ack;
output [7 : 0]  fab_op_data;
output          ip_empty; 

output state;
whole_state reg state;
reg             framestart;
reg             npc_rst_n;
reg             ip_empty;
reg             rx_rd_req;
reg             rx_ip_soc;
reg             ctr_sz;
reg             ctr_id;
reg             fab_ip_ack;
reg  [7 : 0]    rx_ip_data;
reg  [7 : 0]    mem_ip_data;
reg  [7 : 0]    fab_op_data;
wire            ip_empty_ran;
wire            npc_rst_n_ran;
wire            rx_rd_req_ran;
wire            rx_ip_soc_ran;
wire            ctr_sz_ran;
wire            ctr_id_ran;
wire            fab_ip_ack_ran;
wire  [3 : 0]   rx_ip_data_ranL;
wire  [3 : 0]   rx_ip_data_ranM;
wire  [3 : 0]   mem_ip_data_ranL;
wire  [3 : 0]   mem_ip_data_ranM;
wire  [3 : 0]   fab_op_data_ranL;
wire  [3 : 0]   fab_op_data_ranM;
wire tmp;
reg data_tmp;
reg  [7 : 0]    rx_ip_data_S4;
reg  [7 : 0]    rx_ip_data_S5;
reg  [7 : 0]    rx_ip_data_S6;
reg  [7 : 0]    rx_ip_data_S7;
reg  [7 : 0]    rx_ip_data_S8;
reg  [7 : 0]    rx_ip_data_S3;
initial begin
        state = S15;
        framestart = 0;
        ip_empty = 0;
        npc_rst_n = 1;
        rx_rd_req = 0;
        rx_ip_soc = 0;
        ctr_sz = 0;
        ctr_id = 0;
        fab_ip_ack = 0;
        rx_ip_data = 0;
        mem_ip_data = 0;
        fab_op_data = 0;
        rx_ip_data_S4 = 0;
        rx_ip_data_S5 = 0;
        rx_ip_data_S6 = 0;
        rx_ip_data_S7 = 0;
        rx_ip_data_S8 = 0;
        rx_ip_data_S3 = 0;
end

assign npc_rst_n_ran = $ND(0, 1);
assign ip_empty_ran = $ND(0, 1);
assign rx_rd_req_ran = $ND(0, 1);
assign rx_ip_soc_ran = $ND(0, 1);
assign ctr_sz_ran = $ND(0, 1);
assign ctr_id_ran = $ND(0, 1);
assign fab_ip_ack_ran = $ND(0, 1);
assign tmp = $ND(0, 1);

assign rx_ip_data_ranL = $ND(0, 1, 2, 3, 4, 5, 6, 7, 8,
                              9, 10, 11, 12, 13, 14, 15);
assign rx_ip_data_ranM = $ND(0, 1, 2, 3, 4, 5, 6, 7, 8,
                              9, 10, 11, 12, 13, 14, 15);
assign mem_ip_data_ranL = $ND(0, 1, 2, 3, 4, 5, 6, 7, 8,
                                  9, 10, 11, 12, 13, 14, 15);
assign mem_ip_data_ranM = $ND(0, 1, 2, 3, 4, 5, 6, 7, 8,
                                  9, 10, 11, 12, 13, 14, 15);
assign fab_op_data_ranL = $ND(0, 1, 2, 3, 4, 5, 6, 7, 8,
                                  9, 10, 11, 12, 13, 14, 15);
assign fab_op_data_ranM = $ND(0, 1, 2, 3, 4, 5, 6, 7, 8,
                                  9, 10, 11, 12, 13, 14, 15);

always @ ( posedge clock ) begin

 case ( state ) 
     S1: state = S2;
     S2: state = S3;
     S3: state = S4;
     S4: state = S5;
     S5: state = S6;
     S6: state = S7;
     S7: state = S8;
     S8: state = S9;
     S9: state = S10;
     S10: state = S11;
     S11: state = S12;
     S12: state = S13;
     S13: state = S14;
     S14: state = S15;
     S15: state = S1;
 endcase
// set framestate according to the behavior
 if(state==S1)
   framestart = 1;
 else
   framestart = 0;
// Assume rx_ip_soc asserted at state S3
 if (state ==S2) 
   rx_ip_soc = 1;
 else
   rx_ip_soc = 0;
   ip_empty = 1;
   rx_rd_req=1;
   ctr_sz = 0;
   ctr_id = 0;
   npc_rst_n = 1;
   rx_ip_data[3:0] = rx_ip_data_ranL;
   rx_ip_data[7:4] = rx_ip_data_ranM;
   mem_ip_data[3:0] = mem_ip_data_ranL;
   mem_ip_data[7:4] = mem_ip_data_ranM;
   fab_op_data[3:0] = fab_op_data_ranL;
   fab_op_data[7:4] = fab_op_data_ranM;
 if (state == S4)
   begin
   rx_ip_data_S4[3:0] = rx_ip_data_ranL;
   rx_ip_data_S4[7:4] = rx_ip_data_ranM;
   end
 else if (state==S5)
   begin
   rx_ip_data_S5[3:0] = rx_ip_data_ranL;
   rx_ip_data_S5[7:4] = rx_ip_data_ranM;
   end
 else if (state==S6)
   begin
   rx_ip_data_S6[3:0] = rx_ip_data_ranL;
   rx_ip_data_S6[7:4] = rx_ip_data_ranM;
   end
 else if (state==S7)
   begin
   rx_ip_data_S7[3:0] = rx_ip_data_ranL;
   rx_ip_data_S7[7:4] = rx_ip_data_ranM;
   end
 else if (state==S8)
   begin
   rx_ip_data_S8[3:0] = rx_ip_data_ranL;
   rx_ip_data_S8[7:4] = rx_ip_data_ranM;
   end
 else if (state==S3)
   begin
   rx_ip_data_S3[3:0] = rx_ip_data_ranL;
   rx_ip_data_S3[7:4] = rx_ip_data_ranM;
   end
   
  

end 
endmodule

