# Property 4: when input null port controller has a cell to send and it will
#             transfer data and increment address properly. if it does not
#             receive positive acknowledgment signal, it will stop sending
#             data; otherwise, it will send data continually.

# Sub-property 1. During state S1, S2 and S3, the memory address will not
#                 change.
AG(state = S1 -> ip_mem_addr_r[8] == input_data0.ip_mem_addr_r_s1[8] *
                     ip_mem_addr_r[0] == input_data0.ip_mem_addr_r_s1[0] *
                     ip_mem_addr_c[8] == input_data0.ip_mem_addr_c_s1[8] *
                     ip_mem_addr_c[0] == input_data0.ip_mem_addr_c_s1[0] );
AG(state = S1 -> AX (ip_mem_addr_r[8] == input_data0.ip_mem_addr_r_s1[8] *
                     ip_mem_addr_r[0] == input_data0.ip_mem_addr_r_s1[0] *
                     ip_mem_addr_c[8] == input_data0.ip_mem_addr_c_s1[8] *
                     ip_mem_addr_c[0] == input_data0.ip_mem_addr_c_s1[0] ));
AG(state = S1 -> AX AX (ip_mem_addr_r[8] == input_data0.ip_mem_addr_r_s1[8] *
                     ip_mem_addr_r[0] == input_data0.ip_mem_addr_r_s1[0] *
                     ip_mem_addr_c[8] == input_data0.ip_mem_addr_c_s1[8] *
                     ip_mem_addr_c[0] == input_data0.ip_mem_addr_c_s1[0] ));
# Sub-property 2. From state S4 to S12, the memory column address will
#                 increment by 1 per clock cycle
AG(state = S4 + state = S5 + state = S6 + state = S7 + state = S8 + state = S9
   + state = S10 + state = S11 + state = S12
                  -> ip_mem_addr_r[8] == input_data0.ip_mem_addr_r_s1[8] *
                     ip_mem_addr_r[0] == input_data0.ip_mem_addr_r_s1[0] *
                     ip_mem_addr_c[8] == npc0.ip_mem_addr_c_plus1[8] *
                     ip_mem_addr_c[0] == npc0.ip_mem_addr_c_plus1[0] );
# Sub-property 3: At S13, it will be pointed to the first data byte if the
#                 input null port controller received a negative acknowledgment
#                 it will continue to increment at S13 if it receives a
#                 positive acknowledgment signal.
AG(state = S11 * input_data0.fab_ip_ack = 1 ->
   AX AX (  ip_mem_addr_r[8] == input_data0.ip_mem_addr_r_s1[8] *
                     ip_mem_addr_r[0] == input_data0.ip_mem_addr_r_s1[0] *
                     ip_mem_addr_c[8] == npc0.ip_mem_addr_c_plus1[8] *
                     ip_mem_addr_c[0] == npc0.ip_mem_addr_c_plus1[0] ));
AG(state = S11 * input_data0.fab_ip_ack = 0 ->
   AX AX (  ip_mem_addr_r[8] == input_data0.ip_mem_addr_r_s1[8] *
                     ip_mem_addr_r[0] == input_data0.ip_mem_addr_r_s1[0] *
                     ip_mem_addr_c[8] == input_data0.ip_mem_addr_c_s1[8] *
                     ip_mem_addr_c[0] == input_data0.ip_mem_addr_c_s1[0] ));
# Sub-property 4: At S14, it will point to the first data byte because the
#                 input port controller has finished transferred a complete
#                 cell.
AG(state = S14 -> ip_mem_addr_r[8] == input_data0.ip_mem_addr_r_s1[8] *
                     ip_mem_addr_r[0] == input_data0.ip_mem_addr_r_s1[0] *
                     ip_mem_addr_c[8] == input_data0.ip_mem_addr_c_s1[8] *
                     ip_mem_addr_c[0] == input_data0.ip_mem_addr_c_s1[0]);
# Sub-property 5: At state S1, S2, ip_fab_data = 0;
AG (state = S1 + state = S2  -> npc0.ip_fab_data[7] = 0 *
                                            npc0.ip_fab_data[0] = 0);
# Sub-property 6: At state S4 to S12, ip_fab_data is transferred from the
#                 memory to inputs of the fabric with one clock cycle delay.
AG (state = S4 + state = S5 + state = S6 + state = S7 + state = S8 +
    state = S9 + state = S10 + state = S11 + state = S12 ->
    ip_fab_data[7] == npc0.mem_ip_data_r1[7] *
    ip_fab_data[0] == npc0.mem_ip_data_r1[0]);
# --Sub-property 7: At S13, if input null port controller receives a positive
# -- acknowledgment signal at state S11, it will continually transfer a data
# -- byte; otherwise, it will stop sending data.
AG (state = S11 * fab_ip_ack = 1 ->
                  AX AX (ip_fab_data[7] == npc0.mem_ip_data_r1[7]
                       * ip_fab_data[0] == npc0.mem_ip_data_r1[0]));
AG (state = S11 * fab_ip_ack = 0 ->
                  AX AX (ip_fab_data[7] = 0
                       * ip_fab_data[0] = 0));
# -- Sub-property 8: At state S14 and S15, the ip_fab_data is equal to zero
# --                 which means there is no data transfer at these two states.
AG(state = S14 + state = S15 -> ip_fab_data[7] = 0 * ip_fab_data[0] = 0);
# -- Sub-property 9: At state S1 and S2, ip_mem_rd_req will be deasserted
AG ( state = S1 + state = S2  -> ip_mem_rd_req = 0);
# -- Sub-property 10: At state S3 to S12, ip_mem_rd will be asserted
AG (  state = S3 + state = S4 + state = S5 + state = S6 + state = S7
     + state = S8 + state = S9 + state = S10 + state = S11 + state = S12
     -> ip_mem_rd_req = 1);
# -- Sub-property 11: if fab_ip_ack is asserted at S11, it will be asserted at
# --                  state S13; otherwise, it will be deasserted;
AG (state = S11 * fab_ip_ack = 1 -> AX AX (ip_mem_rd_req = 1)); 
AG (state = S11 * fab_ip_ack = 0 -> AX AX (ip_mem_rd_req = 0)); 
# -- Sub-property 12: At state S14 and S15, ip_mem_rd_req will be de-asserted
AG (state = S14 + state = S15 -> ip_mem_rd_req = 0);
