typedef enum { S1, S2, S3, S4, S5, S6, S7, S8,
                S9, S10, S11, S12, S13, S14, S15, S16,
                S17, S18, S19, S20, S21, S22, S23, S24,
                S25, S26, S27, S28, S29, S30, S31, S32,
                S33, S34, S35, S36, S37, S38, S39, S40,
                S41, S42, S43, S44, S45, S46, S47, S48,
                S49, S50, S51, S52, S53, S54, S55, S56,
                S57, S58, S59, S60, S61, S62, S63, S64} whole_state;

module environment ( clock );

input clock;
output[7:0]     ip_mem_data;
output[7:0]     ip_fab_data;
output[8:0]     ip_mem_addr_r;
output[8:0]     ip_mem_addr_c;
output          ip_mem_rd_req;
output          ip_mem_wr_en;
output[7:0]     op_fifo_data;
output          op_fifo_wr_en;
output          op_fab_ack;
output          op_fifo_soc;
wire            framestart;
wire            npc_rst_n;
wire            ip_empty;
wire            rx_rd_req;
wire            rx_ip_soc;
wire [7:0]      rx_ip_data;
wire            ctr_sz;
wire            ctr_ip;
wire            fab_ip_ack;
wire            fab_op_data;

whole_state wire state;
npc  npc0(framestart, 
                clock,
                npc_rst_n,
                ip_empty,
                rx_rd_req,                              
                rx_ip_soc,
                rx_ip_data,
                ctr_sz,
                ctr_id,
                ip_mem_data,
                mem_ip_data,
                ip_fab_data,
                fab_ip_ack,
                ip_mem_addr_r,
                ip_mem_addr_c,
                ip_mem_rd_req,
                ip_mem_wr_en,
                fab_op_data,
                op_fifo_data,
                op_fifo_wr_en,
                op_fab_ack,
                op_fifo_soc
                );
input_data input_data0(
                state, 
                framestart, 
                clock,
                npc_rst_n,
                ip_empty,
                rx_rd_req,                              
                rx_ip_soc,
                rx_ip_data,
                ctr_sz,
                ctr_id,
                mem_ip_data,
                fab_ip_ack,
                fab_op_data
                );

endmodule

module input_data(
                state,
                framestart, 
                clock,
                npc_rst_n,
                ip_empty, 
                rx_rd_req,
                rx_ip_soc,
                rx_ip_data,
                ctr_sz,
                ctr_id,
                mem_ip_data,
                fab_ip_ack,
                fab_op_data
                );
input           clock;
output          framestart;
output          npc_rst_n;
output          rx_rd_req;
output          rx_ip_soc;
output [7 : 0]  rx_ip_data;
output          ctr_sz;
output          ctr_id;
output [7 : 0]  mem_ip_data;
output          fab_ip_ack;
output [7 : 0]  fab_op_data;
output          ip_empty; 

output state;
whole_state reg state;
reg             framestart;
reg             npc_rst_n;
reg             ip_empty;
reg             rx_rd_req;
reg             rx_ip_soc;
reg             ctr_sz;
reg             ctr_id;
reg             fab_ip_ack;
reg  [7 : 0]    rx_ip_data;
reg  [7 : 0]    mem_ip_data;
reg  [7 : 0]    fab_op_data;
wire            ip_empty_ran;
wire            npc_rst_n_ran;
wire            rx_rd_req_ran;
wire            rx_ip_soc_ran;
wire            ctr_sz_ran;
wire            ctr_id_ran;
wire            fab_ip_ack_ran;
wire  [3 : 0]   rx_ip_data_ranL;
wire  [3 : 0]   rx_ip_data_ranM;
wire  [3 : 0]   mem_ip_data_ranL;
wire  [3 : 0]   mem_ip_data_ranM;
wire  [3 : 0]   fab_op_data_ranL;
wire  [3 : 0]   fab_op_data_ranM;
wire tmp;
reg data_tmp;
reg  [7 : 0]    rx_ip_data_S4;
reg  [7 : 0]    rx_ip_data_S5;
reg  [7 : 0]    rx_ip_data_S6;
reg  [7 : 0]    rx_ip_data_S7;
reg  [7 : 0]    rx_ip_data_S8;
reg  [7 : 0]    rx_ip_data_S55;
initial begin
        state = S64;
        framestart = 0;
        ip_empty = 0;
        npc_rst_n = 1;
        rx_rd_req = 0;
        rx_ip_soc = 0;
        ctr_sz = 0;
        ctr_id = 0;
        fab_ip_ack = 0;
        rx_ip_data = 0;
        mem_ip_data = 0;
        fab_op_data = 0;
        rx_ip_data_S4 = 0;
        rx_ip_data_S5 = 0;
        rx_ip_data_S6 = 0;
        rx_ip_data_S7 = 0;
        rx_ip_data_S8 = 0;
        rx_ip_data_S55 = 0;
end

assign npc_rst_n_ran = $ND(0, 1);
assign ip_empty_ran = $ND(0, 1);
assign rx_rd_req_ran = $ND(0, 1);
assign rx_ip_soc_ran = $ND(0, 1);
assign ctr_sz_ran = $ND(0, 1);
assign ctr_id_ran = $ND(0, 1);
assign fab_ip_ack_ran = $ND(0, 1);
assign tmp = $ND(0, 1);

assign rx_ip_data_ranL = $ND(0, 1, 2, 3, 4, 5, 6, 7, 8,
                              9, 10, 11, 12, 13, 14, 15);
assign rx_ip_data_ranM = $ND(0, 1, 2, 3, 4, 5, 6, 7, 8,
                              9, 10, 11, 12, 13, 14, 15);
assign mem_ip_data_ranL = $ND(0, 1, 2, 3, 4, 5, 6, 7, 8,
                                  9, 10, 11, 12, 13, 14, 15);
assign mem_ip_data_ranM = $ND(0, 1, 2, 3, 4, 5, 6, 7, 8,
                                  9, 10, 11, 12, 13, 14, 15);
assign fab_op_data_ranL = $ND(0, 1, 2, 3, 4, 5, 6, 7, 8,
                                  9, 10, 11, 12, 13, 14, 15);
assign fab_op_data_ranM = $ND(0, 1, 2, 3, 4, 5, 6, 7, 8,
                                  9, 10, 11, 12, 13, 14, 15);

always @ ( posedge clock ) begin

 case ( state ) 
     S1: state = S2;
     S2: state = S3;
     S3: state = S4;
     S4: state = S5;
     S5: state = S6;
     S6: state = S7;
     S7: state = S8;
     S8: state = S9;
     S9: state = S10;
     S10: state = S11;
     S11: state = S12;
     S12: state = S13;
     S13: state = S14;
     S14: state = S15;
     S15: state = S16;
     S16: state = S17;
     S17: state = S18;
     S18: state = S19;
     S19: state = S20;
     S20: state = S21;
     S21: state = S22;
     S22: state = S23;
     S23: state = S24;
     S24: state = S25;
     S25: state = S26;
     S26: state = S27;
     S27: state = S28;
     S28: state = S29;
     S29: state = S30;
     S30: state = S31;
     S31: state = S32;
     S32: state = S33;
     S33: state = S34;
     S34: state = S35;
     S35: state = S36;
     S36: state = S37;
     S37: state = S38;
     S38: state = S39;
     S39: state = S40;
     S40: state = S41;
     S41: state = S42;
     S42: state = S43;
     S43: state = S44;
     S44: state = S45;
     S45: state = S46;
     S46: state = S47;
     S47: state = S48;
     S48: state = S49;
     S49: state = S50;
     S50: state = S51;
     S51: state = S52;
     S52: state = S53;
     S53: state = S54;
     S54: state = S55;
     S55: state = S56;
     S56: state = S57;
     S57: state = S58;
     S58: state = S59;
     S59: state = S60;
     S60: state = S61;
     S61: state = S62;
     S62: state = S63;
     S63: state = S64;
     S64: state = S1;
 
 endcase
// set framestate according to the behavior
 if(state==S1)
   framestart = 1;
 else
   framestart = 0;
// Assume rx_ip_soc asserted at state S3
 if (state ==S3) 
   rx_ip_soc = 1;
 else
   rx_ip_soc = 0;
   ip_empty = 1;
   rx_rd_req=1;
   ctr_sz = 0;
   ctr_id = 0;
   npc_rst_n = 1;
   rx_ip_data[3:0] = rx_ip_data_ranL;
   rx_ip_data[7:4] = rx_ip_data_ranM;
   mem_ip_data[3:0] = mem_ip_data_ranL;
   mem_ip_data[7:4] = mem_ip_data_ranM;
   fab_op_data[3:0] = fab_op_data_ranL;
   fab_op_data[7:4] = fab_op_data_ranM;
 if (state == S4)
   begin
   rx_ip_data_S4[3:0] = rx_ip_data_ranL;
   rx_ip_data_S4[7:4] = rx_ip_data_ranM;
   end
 else if (state==S5)
   begin
   rx_ip_data_S5[3:0] = rx_ip_data_ranL;
   rx_ip_data_S5[7:4] = rx_ip_data_ranM;
   end
 else if (state==S6)
   begin
   rx_ip_data_S6[3:0] = rx_ip_data_ranL;
   rx_ip_data_S6[7:4] = rx_ip_data_ranM;
   end
 else if (state==S7)
   begin
   rx_ip_data_S7[3:0] = rx_ip_data_ranL;
   rx_ip_data_S7[7:4] = rx_ip_data_ranM;
   end
 else if (state==S8)
   begin
   rx_ip_data_S8[3:0] = rx_ip_data_ranL;
   rx_ip_data_S8[7:4] = rx_ip_data_ranM;
   end
 else if (state==S55)
   begin
   rx_ip_data_S55[3:0] = rx_ip_data_ranL;
   rx_ip_data_S55[7:4] = rx_ip_data_ranM;
   end
   
  

end 
endmodule


/////////////////////// The Fairisle Null Port Controller///////////////////// 
//  File Name: pnc_rtl.v                      
//  Designer: Jianping Lu
//  Description: The design is based on the Fairisle Null Port Controller
//   designed by Cambridge University.The implementation which is done here
//   is only for research purpose.
/////////////////////////////////////////////////////////////////////////////
  
//`define ip_idle                         3'b000
//`define rx_wait                         3'b001
//`define rx_store1                       3'b010
//`define rx_store2                       3'b011
//`define rx_data                         3'b100
//`define tx_addr                         3'b101
//`define tx_first5_data                  3'b110
//`define tx_data                         3'b111

//`define op_idle                         1'b0
//`define op_rx_data                      1'b1
typedef enum {ip_idle, rx_wait, rx_store1, rx_store2, rx_data, tx_addr,
              tx_first5_data, tx_data} input_npc_state;
typedef enum {op_idle, op_rx_data} output_npc_state;
 
module npc (framestart, 
                clk,
                npc_rst_n,
                ip_empty, 
                rx_rd_req,                              
                rx_ip_soc,
                rx_ip_data,
                ctr_sz,
                ctr_id,
                ip_mem_data,
                mem_ip_data,
                ip_fab_data,
                fab_ip_ack,
                ip_mem_addr_r,
                ip_mem_addr_c,
                ip_mem_rd_req,
                ip_mem_wr_en,
                fab_op_data,
                op_fifo_data,
                op_fifo_wr_en,
                op_fab_ack,
                op_fifo_soc
                );

input framestart;       // A synchrounous signal, and equal to 64 clock cycles
input clk;  // clock signal
input npc_rst_n; // reset signal
input ip_empty;
input rx_rd_req; // indicate the receive board has sth to send
input rx_ip_soc;        // SOC signal from receive board to indicate the
                          //start of cell if it asserts
input [7 : 0]  rx_ip_data;       // Input data from receive board to the
                                   //input port controller;
input ctr_sz; // For debugging, when set, cell will be put in row0, column 0
                //to 63
input ctr_id; // To prevent the data cell being written into the memory
                // before new VCIs, FRB and
                        // PRB are written into the memory.     
output[7:0] ip_mem_data;      // The output data from the input port
                                // controller to memory. 
input[7:0]  mem_ip_data;        // The input data from the memory to the ip
output [7:0] ip_fab_data;    // The data from input port controller to the
                               //fabric
input   fab_ip_ack;  //acknowledge signal from the fabric to the input port
                       // controller
output [8 :0] ip_mem_addr_r; // row address of the memory given by IP
output[8 :0] ip_mem_addr_c; // column address of the memory given by IP
output ip_mem_rd_req;  //read request signal
output ip_mem_wr_en; // write enable signal 
input [7 : 0] fab_op_data; //data from fabric to output port controller
output [7:0] op_fifo_data; // data from output port controller to the fifo
output op_fifo_wr_en; // fifo write enable signal
output op_fab_ack;  // acknowledgment signal from output port controller to
                      // the fabric
output op_fifo_soc;  // start of cell signal from  op to fifo

reg [7 : 0] ip_mem_data;
reg [7 : 0] ip_fab_data;
reg [8 : 0] ip_mem_addr_r, ip_mem_addr_c;
reg ip_mem_rd_req, ip_mem_wr_en;
reg [7:0] op_fifo_data;
reg op_fab_ack;
reg op_fifo_soc;
reg op_fifo_wr_en;
input_npc_state reg  ip_state_i;
output_npc_state reg op_state_i;
reg [5 : 0] ip_cell_cnt, op_cell_cnt;
initial begin
     ip_mem_data = 0;
     ip_fab_data = 0;
     ip_mem_addr_r = 0;
     ip_mem_addr_c = 0;
     ip_mem_addr_c = 0;
     ip_mem_rd_req = 0;
     ip_mem_wr_en = 0;
     op_fifo_data = 0;
     op_fab_ack = 0;
     op_fifo_soc = 0;
     op_fifo_wr_en = 0;
     ip_state_i = ip_idle;
     op_state_i = op_idle;
     ip_cell_cnt = 0;
     op_cell_cnt = 0;
end

// Process: ip_main_state
// Description: If ip_empty is '1', when framestart asserts, ip detects the
//              rx_soc signal, if it asserts, read the data following the
//              signal, and latches the first two bytes (VCIs) 
//              which will become the row and column address of a cell. when
//              ip_empty is '0', it tries to ransmit a cell. At four clock
//              cycle after it transmits data, if it cannot receive 
//              the acknowledgment signal, it stops transmitting. 
 
always @(posedge clk or npc_rst_n) begin 
if (npc_rst_n == 0) 
        ip_state_i = ip_idle;
else begin 
        case (ip_state_i) 
                ip_idle: if (ip_empty == 1 && framestart ==1 && rx_rd_req==1
                             && ctr_id == 0) 
                                ip_state_i = rx_wait;
                           else if (ip_empty == 0 && framestart == 1
                                    && ctr_id== 0)
                                ip_state_i = tx_addr;
                           else ip_state_i = ip_idle;
                rx_wait: if (rx_ip_soc == 1) 
                                ip_state_i = rx_store1;
                rx_store1: ip_state_i = rx_store2;
                rx_store2: ip_state_i = rx_data;
                rx_data: if (ip_cell_cnt == 1)
                              ip_state_i = ip_idle;
                           else
                                ip_state_i = rx_data;
                tx_addr: ip_state_i = tx_first5_data;
                tx_first5_data: if (ip_cell_cnt == (54-5) && fab_ip_ack == 0)
                                        ip_state_i = ip_idle;
                                    else if (ip_cell_cnt==(54-5)
                                             && fab_ip_ack == 1)
                                        ip_state_i = tx_data;
                                    else
                                      ip_state_i = tx_first5_data;
                tx_data: if (ip_cell_cnt == 1)
                                        ip_state_i = ip_idle;
                           else
                                        ip_state_i = tx_data;
        endcase
 end
end


// Process: ip_cell_cnt, define the ip_cell_cnt;

always @(npc_rst_n or posedge clk) begin
        if (npc_rst_n == 0) 
                ip_cell_cnt = 0;
        else if (ip_state_i == rx_store2)
                ip_cell_cnt = 50;
        else if (ip_state_i == tx_addr)
                ip_cell_cnt = 54;
        else if (ip_cell_cnt == 1 || ip_cell_cnt == 0)
                ip_cell_cnt = 0;
        else ip_cell_cnt = ip_cell_cnt -1;
end

// Process: define ip_mem_addr_c, ip_mem_addr_r

always @(npc_rst_n or posedge clk) begin 
        if (npc_rst_n == 0)  
        begin
                ip_mem_addr_c = 0;
                ip_mem_addr_r = 0;
        end
        else if (ctr_sz == 1)
        begin
                if (ip_state_i == ip_idle 
                        || ip_state_i == rx_store1
                        || ip_state_i == rx_store2
                        || ip_state_i == tx_addr)
                begin
                        ip_mem_addr_r =  9'b000000000;
                        ip_mem_addr_c =  9'b000000000;
                end
                else if (ip_state_i == rx_data 
                        || ip_state_i == tx_first5_data
                        || ip_state_i == tx_data)
                begin
                        ip_mem_addr_r = 9'b000000000;
                        ip_mem_addr_c[8:6] = 3'b000;
                        ip_mem_addr_c[5:0] = ip_mem_addr_c[5:0] + 1;
                end
        end
        else    
        begin
                if (ip_state_i == rx_store1)
                        ip_mem_addr_r[8:1] =  rx_ip_data;
                else if (ip_state_i == rx_store2)
                begin
                        ip_mem_addr_r[0] = rx_ip_data[7];
                        ip_mem_addr_r[8:1] = ip_mem_addr_r[8:1];
                        ip_mem_addr_c[8:6] = rx_ip_data[6:4];
                        ip_mem_addr_c[5:0] = 6'b000100;
                end
                else if (ip_state_i == rx_data)
                begin
                        ip_mem_addr_r  = ip_mem_addr_r;
                        ip_mem_addr_c[5:0] = ip_mem_addr_c[5:0] + 1;
                        ip_mem_addr_c[8:6] = ip_mem_addr_c[8:6];
                end
                else if (ip_state_i == ip_idle) 
                begin
                        ip_mem_addr_r = ip_mem_addr_r;
                        ip_mem_addr_c[8:6] = ip_mem_addr_c[8:6];
                        ip_mem_addr_c[5:0] = 6'b000000;
                end
                else if (ip_state_i == tx_addr)
                begin
                        ip_mem_addr_r = ip_mem_addr_r;
                        ip_mem_addr_c = ip_mem_addr_c;
                end
                else if (ip_state_i == tx_first5_data || 
                        ip_state_i == tx_data)
                begin
                        ip_mem_addr_r = ip_mem_addr_r;
                        ip_mem_addr_c[8:6] = ip_mem_addr_c[8:6];
                        ip_mem_addr_c[5:0] = ip_mem_addr_c[5:0] + 1;
                end     
        end
end

// process: ip_mem_data, ip_mem_wr_en, define the data from ip to mem
always @(posedge clk or npc_rst_n) begin
        if (npc_rst_n == 0)
        begin
                ip_mem_data = 0;
                ip_mem_wr_en = 0;
        end
        else if (ip_state_i == rx_data)
        begin
                ip_mem_data = rx_ip_data;
                ip_mem_wr_en = 1;
        end
        else begin
                ip_mem_data = ip_mem_data;
                ip_mem_wr_en = 0;
        end
end
        
// process: ip_fab_data, ip_mem_rd_req, define these two signals
always @(posedge clk or npc_rst_n) begin
        if (npc_rst_n == 0)
        begin
                ip_fab_data = 0;
                ip_mem_rd_req = 0;      
        end
        else if (ip_state_i == tx_first5_data 
                || ip_state_i == tx_data)
        begin
                ip_fab_data = mem_ip_data;
                ip_mem_rd_req = 1;
        end
        else 
        begin
                ip_fab_data = 9'b00000000;
                ip_mem_rd_req = 0;
        end
end

// Process: define ip_empty signal
//always @(posedge clk or npc_rst_n)
//begin 
//     if (npc_rst_n == 0)
//                ip_empty = 1;
//        else if ((ip_state_i == rx_data && ip_cell_cnt == 1)
//                || (ip_state_i == tx_data && ip_cell_cnt == 1))
//                ip_empty = ~ip_empty;
//        else
//                ip_empty = ip_empty;
//end

// Process: define op_state_i
always @(posedge clk or npc_rst_n)
begin
        if (npc_rst_n == 0)
                op_state_i = op_idle;
        else
          begin 
                case (op_state_i)
                op_idle: 
                         if (op_cell_cnt == 5 && fab_op_data[0] == 1)
                                op_state_i = op_rx_data;
                         else op_state_i = op_idle;
                op_rx_data: 
                        if (op_cell_cnt == 57)  //5 + 52 
                                op_state_i = op_idle;
                        else op_state_i = op_rx_data;
                endcase
           end
end

// Process: define op_fifo_data, op_fifo_soc, op_fifo_wr_en, op_fab_ack

always @(posedge clk or npc_rst_n) begin
        if (npc_rst_n == 0) begin
                op_fifo_data = 0;
                op_fifo_soc = 0;
                op_fifo_wr_en = 0;
                op_fab_ack = 0;
        end
        else if (op_cell_cnt == 5 && fab_op_data[0] == 1)
                op_fifo_soc = 1;
        else if (op_state_i == op_rx_data)
        begin
                op_fifo_soc = 0;
                op_fifo_data = fab_op_data;
                op_fifo_wr_en = 1;
                op_fab_ack = 1;
        end
        else
        begin
                op_fifo_soc = 0;
                op_fifo_data = 0;
                op_fifo_wr_en = 0;
                op_fab_ack = 0;
        end
end

endmodule



